//#include <cstring>
#include <iostream> // TEST

#include "a_Chess_bitboard.h"

//-----------------------------------------------------------------------------------
/* +
 *    (Brenkman Andrey)
 *   23.11.2010
*/
//-----------------------------------------------------------------------------------

/*
    

*/

//	===================================================================
//   .          
void Chess_bitboard::print_name_from_coord()
{

	for (unsigned __int8 i = 0; i < 8; i++)
	{
		for (unsigned __int8 j = 0; j < 8; j++)
		{
			std::cout << white_name_from_coord[(7 - i) * 8 + j];
		}

		std::cout << "\n";
	}

	std::cout << "\n";

	for (unsigned __int8 i = 0; i < 8; i++)
	{
		for (unsigned __int8 j = 0; j < 8; j++)
		{
			std::cout << black_name_from_coord[(7 - i) * 8 + j];
		}

		std::cout << "\n";
	}

	//for (int i= 0; i < 64; i++)
	//{
	//	std::cout << bitboard->white_name_from_coord[i];
	//	if( i%8 == 7)
	//{
	//		std::cout << "\n";
	//}
	//}
}

//	===================================================================
//   .  
void Chess_bitboard::save_test_bitboard
(
	const class Chess_bitboard * const p_bitboard//  
)
{

	all_piece = p_bitboard->all_piece;//  
	all_white_piece = p_bitboard->all_white_piece;//   
	all_black_piece = p_bitboard->all_black_piece;//   
	colour_move = p_bitboard->colour_move;
	taking_passage_yes = p_bitboard->taking_passage_yes;
	taking_passage_x = p_bitboard->taking_passage_x;
	taking_passage_y = p_bitboard->taking_passage_y;
	castling_Q = p_bitboard->castling_Q;
	castling_K = p_bitboard->castling_K;
	castling_q = p_bitboard->castling_q;
	castling_k = p_bitboard->castling_k;
	hash_key =  p_bitboard->hash_key;
	value_white_material = p_bitboard->value_white_material;
	value_black_material = p_bitboard->value_black_material;

	for (unsigned __int8 n =0; n < 7; n++ )
	{
		white_piece[n] = p_bitboard->white_piece[n];
		black_piece[n] = p_bitboard->black_piece[n];
	}

	for (unsigned __int8 k =0; k < 64; k++ )
	{
		white_name_from_coord[k] = p_bitboard->white_name_from_coord[k];
		black_name_from_coord[k] = p_bitboard->black_name_from_coord[k];
	}
}

//	===================================================================
//   .  
void Chess_bitboard::compare_test_bitboard
(
	const class Chess_bitboard * const p_bitboard//  
)
{
	//       
	if (all_piece != p_bitboard->all_piece)
	{
		std::cout << "white test_all_piece != bitboard->all_piece" << "\n";//  
	}

	if (all_white_piece != p_bitboard->all_white_piece)
	{
		std::cout << "white test_all_white_piece != bitboard->all_white_piece" << "\n";//   
	}

	if (all_black_piece != p_bitboard->all_black_piece) 
	{
		std::cout << "white test_all_black_piece != bitboard->all_black_piece" << "\n";//   
	}

	if (colour_move != p_bitboard->colour_move)
	{
		std::cout << "white test_colour_move != bitboard->colour_move" << "\n";
	}

	if (taking_passage_yes != p_bitboard->taking_passage_yes)
	{
		std::cout << "white test_taking_passage_yes != bitboard->taking_passage_yes" << "\n";
	}

	if (taking_passage_x != p_bitboard->taking_passage_x)
	{
		std::cout << "white test_taking_passage_x != bitboard->taking_passage_x" << "\n";
	}

	if (taking_passage_y != p_bitboard->taking_passage_y)
	{
		std::cout << "white test_taking_passage_y != bitboard->taking_passage_y" << "\n";
	}

	if (castling_Q != p_bitboard->castling_Q)
	{
		std::cout << "white test_castling_Q != bitboard->castling_Q" << "\n";
	}

	if (castling_K != p_bitboard->castling_K)
	{
		std::cout << "white test_castling_K != bitboard->castling_K" << "\n";
	}

	if (castling_q != p_bitboard->castling_q)
	{
		std::cout << "white test_castling_q != bitboard->castling_q" << "\n";
	}

	if (castling_k != p_bitboard->castling_k)
	{
		std::cout << "white test_castling_k != bitboard->castling_k" << "\n";
	}

	if (hash_key !=  p_bitboard->hash_key)
	{
		std::cout << "white test_hash_key !=  bitboard->hash_key" << "\n";
	}

	if (value_white_material != p_bitboard->value_white_material)
	{
		std::cout << "white test_value_white_material != bitboard->value_white_material" << "\n";
	}

	if (value_black_material != p_bitboard->value_black_material)
	{
		std::cout << "white test_value_black_material != bitboard->value_black_material" << "\n";
	}



	for (unsigned __int8 n2 = 0; n2 < 7; n2++ )
	{
		if (white_piece[n2] != p_bitboard->white_piece[n2])
		{
			std::cout << "white test_white_piece[n] = bitboard->white_piece[n]" << n2 << "\n";
		}

		if (black_piece[n2] != p_bitboard->black_piece[n2])
		{
			std::cout << "white test_black_piece[n] = bitboard->black_piece[n]" << n2 << "\n";
		}
	}

	for (unsigned __int8 k2 = 0; k2 < 64; k2++ )
	{
		if (white_name_from_coord[k2] != p_bitboard->white_name_from_coord[k2])
		{
			std::cout << "white test_white_name_from_coord[k] = bitboard->white_name_from_coord[k]" << k2 << "\n";
		}

		if (black_name_from_coord[k2] != p_bitboard->black_name_from_coord[k2])
		{
			std::cout << "white test_black_name_from_coord[k] = bitboard->black_name_from_coord[k]" << k2 << "\n";
		}
	}

}
